datablock ParticleData(PawnchRingParticle) {
   dragCoefficient = "3";
   windCoefficient = "0";
   gravityCoefficient = "0";
   inheritedVelFactor = "1";
   constantAcceleration = "5";
   lifetimeMS = "500";
   lifetimeVarianceMS = "100";
   spinSpeed = "0";
   spinRandomMin = "0";
   spinRandomMax = "0";
   useInvAlpha = "0";
   animateTexture = "0";
   framesPerSec = "1";
   textureName = "base/data/particles/star1";
   animTexName[0] = "base/data/particles/star1";
   colors[0] = "0 0 1 1";
   colors[1] = "0 0 0.5 0.5";
   colors[3] = "0 0 0 0";
   sizes[0] = "1";
   sizes[1] = "0.3";
   sizes[2] = "0";
   times[0] = "0";
   times[1] = "0.5";
   times[2] = "1";
};
datablock ParticleEmitterData(PawnchRingEmitter) {
   className = "ParticleEmitterData";
   ejectionPeriodMS = "1";
   periodVarianceMS = "0";
   ejectionVelocity = "10";
   velocityVariance = "0";
   ejectionOffset = "0";
   thetaMin = "80";
   thetaMax = "90";
   phiReferenceVel = "0";
   phiVariance = "360";
   overrideAdvance = "1";
   orientParticles = "1";
   orientOnVelocity = "1";
   particles = "PawnchRingParticle";
   lifetimeMS = "0";
   lifetimeVarianceMS = "0";
   useEmitterSizes = "0";
   useEmitterColors = "0";
   uiName = "";
   doFalloff = "1";
   doDetail = "1";
};
datablock ParticleData(PawnchTrailParticle) {
   dragCoefficient = "3";
   windCoefficient = "0";
   gravityCoefficient = "0";
   inheritedVelFactor = "1";
   constantAcceleration = "5";
   lifetimeMS = "500";
   lifetimeVarianceMS = "100";
   spinSpeed = "0";
   spinRandomMin = "0";
   spinRandomMax = "0";
   useInvAlpha = "0";
   animateTexture = "0";
   framesPerSec = "1";
   textureName = "base/data/particles/dot";
   animTexName[0] = "base/data/particles/dot";
   colors[0] = "0 0.5 1 1";
   colors[1] = "0 0.25 0.5 0.5";
   colors[3] = "0 0 0 0";
   sizes[0] = "0.1";
   sizes[1] = "1";
   sizes[2] = "0";
   times[0] = "0";
   times[1] = "0.3";
   times[2] = "1";
};
datablock ParticleEmitterData(PawnchTrailEmitter) {
   className = "ParticleEmitterData";
   ejectionPeriodMS = "1";
   periodVarianceMS = "0";
   ejectionVelocity = "10";
   velocityVariance = "0";
   ejectionOffset = "0";
   thetaMin = "0";
   thetaMax = "30";
   phiReferenceVel = "0";
   phiVariance = "360";
   overrideAdvance = "1";
   orientParticles = "1";
   orientOnVelocity = "1";
   particles = "PawnchTrailParticle";
   lifetimeMS = "0";
   lifetimeVarianceMS = "0";
   useEmitterSizes = "0";
   useEmitterColors = "0";
   uiName = "";
   doFalloff = "1";
   doDetail = "1";
};
datablock ProjectileData(PawnchTrailProjectile)
{
   className = "ProjectileData";
   hasLight = true;
   lightRadius = 3;
   lightColor = "0 1 1";
   directDamage = 0;
   particleEmitter = PawnchTrailEmitter;
   explodeOnPlayerImpact = false;
   collideWithPlayers = false;
   lifeTime = 500;
   muzzleVelocity = 0;
   uiname = "";
};
datablock ExplosionData(PawnchRingExplosion)
{
   lifeTimeMS = 500;

   soundProfile = "";

   particleEmitter = PawnchRingEmitter;
   particleDensity = 300;
   particleRadius = 0.3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "100 100 100";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 5;
   camShakeRadius = 50.0;

   lightStartRadius = 30;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 1";
};
datablock ProjectileData(PawnchRingExplosionProjectile)
{
   className = "ProjectileData";
   hasLight = true;
   lightRadius = 3;
   lightColor = "0 1 0";
   directDamage = 0;
   explosion = PawnchRingExplosion;
   particleEmitter = "";
   explodeOnPlayerImpact = false;
   collideWithPlayers = false;
   lifeTime = 150;
   muzzleVelocity = 0;
   uiname = "";
};
function PawnchExplosion(%p,%v)
{
   %a = new Projectile()
   {
      dataBlock = PawnchTrailProjectile;
      initialVelocity = %v;
      initialPosition = %p;
      sourceObject = 0;
      sourceSlot = 0;
      client = 0;
   };
   %b = new Projectile()
   {
      dataBlock = PawnchRingExplosionProjectile;
      initialVelocity = %v;
      initialPosition = %p;
      sourceObject = 0;
      sourceSlot = 0;
      client = 0;
   };
   %b.explode();
}
function servercmdFalconPunch(%c)
{
   if(!%c.isAdmin)
      return;
   if(!isObject(%p=%c.player))
      return;
   %p=%c.player;
   %s=%p.getEyePoint();
   %t=($TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType |$TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
   %v=%p.getMuzzleVector(0);
   %e=vectorAdd(%s,vectorScale(%v,10));
   %r=containerRaycast(%s,%e,%t,%p);
   %o=firstWord(%r);
   if(isObject(%o))
   {
      %a=%p.getForwardVector();
      if(%o.GetType() & $TypeMasks::PlayerObjectType)
      {
         %o.setVelocity(vectorScale(%v,200));
         %o.schedule(5,kill);
         %a=%v;
      }
      PawnchExplosion(posFromRayCast(%r),%a);
      %p.playThread(0,"activate");
   }
}